//+------------------------------------------------------------------+
//|                                                      Sepp EA.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

input double LotSize    = 0.1;  // Fixed Lot (Set 0 to Disable)
input double SLOffset   = 300;
input double Multiplier = 1;
input int    MaxTrades  = 5;
input int    MagicNumber= 6353;

int trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(IsNewCandle())trade=1;
   FindSignal();
   Trailing();
   if((Ask>btp||Ask<bsl) && btp>0 && bsl>0){CLOSEALLB(OP_BUYLIMIT);CLOSEALLB(OP_BUYSTOP);bsl=0;btp=0;}
   if((Ask<stp||Ask>ssl) && stp>0 && ssl>0){CLOSEALLB(OP_SELLLIMIT);CLOSEALLB(OP_SELLSTOP);ssl=0;stp=0;}
  }
//+------------------------------------------------------------------+

void CLOSEALLB(int type)
{  for(int x=OrdersTotal();x>=0;x--)
  {if(!OrderSelect(x,SELECT_BY_POS,MODE_TRADES))continue;
   if(OrderSymbol()!=Symbol())continue;
   //if(OrderMagicNumber()!=MagicNumber)continue;
   if(OrderType()==type)if(OrderDelete(OrderTicket(),clrNONE))continue;
   if(OrderType()==type)if(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrNONE))continue;
   }

}
//+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
   static int BarsOnChart=0;
	if (Bars == BarsOnChart)
	return (false);
	BarsOnChart = Bars;
	return(true);
}

//+-------------------------------
//+ Check Open Orders
//+-------------------------------

int OpenOrdersThisPair(string pair)
{
  int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()== pair) total++;
	  }
	  return (total);
}

//+------------------------------------------------------------------+
//+ Order Entry                                                      |
//+------------------------------------------------------------------+

void OrderEntry(int direction, double price, double sl, double tp)
{
   double lotSize=LotSize;
   lotSize=AccountBalance()/1000;
   lotSize=lotSize/1000;
   lotSize=lotSize*MathPow(10,Multiplier);
   lotSize=NormalizeDouble(lotSize,2);
   
   price=NormalizeDouble(price,Digits);
   tp=NormalizeDouble(tp,Digits);
   sl=NormalizeDouble(sl,Digits);
   
   //Print(tp," ",sl," ",price);
   if(LotSize>0)lotSize=LotSize;
   
   if(OpenOrdersThisPair(Symbol())<1 && trade==1)
   {
   
   int buyticket=0,sellticket=0;   
   if(direction==0)
   {
     if(price>Ask){ 
      buyticket = OrderSend(Symbol(),OP_BUYSTOP,lotSize,price,10,sl,tp,NULL,MagicNumber,0,Green);
      }
     if(price<Ask){ 
      buyticket = OrderSend(Symbol(),OP_BUYLIMIT,lotSize,price,10,sl,tp,NULL,MagicNumber,0,Green);
      }
      trade=0;
   }
   
   if(direction==1)
   {
      if(price>Bid){
      sellticket = OrderSend(Symbol(),OP_SELLLIMIT,lotSize,price,10,sl,tp,NULL,MagicNumber,0,Red);
      }
      if(price<Bid){
      sellticket = OrderSend(Symbol(),OP_SELLSTOP,lotSize,price,10,sl,tp,NULL,MagicNumber,0,Red);
      }
      trade=0;
     
      }
   }
    
}

double dist, bsl, ssl, btp, stp;
void FindSignal(){
   double dbVal1=iCustom(Symbol(),0,"PTS_DoubleTopBottom",10,0);
   double dbVal2=iCustom(Symbol(),0,"PTS_DoubleTopBottom",11,0);
   
   if(OpenOrdersThisPair(Symbol())==0){
   if(dbVal1>0 && dbVal1!=EMPTY_VALUE){
   dist=getHigh()-getLow();
   double etp=getHigh()+(dist*5);
   bsl=getLow();
   btp=getHigh()+(dist*5);
   etp=NormalizeDouble(etp,Digits);
   //Print(dist," ",getHigh()," ",getLow());
      OrderEntry(0,getHigh(),getLow()-(SLOffset*Point),etp);
   }
   if(dbVal2>0 && dbVal2!=EMPTY_VALUE){
   dist=getHigh()-getLow();
   double etp=getLow()-(dist*5);
   etp=NormalizeDouble(etp,Digits);
   ssl=getHigh();
   stp=getLow()-(dist*5);
      OrderEntry(1,getLow(),getHigh()+(SLOffset*Point),etp);
   }
   }
}

double getHigh(){
double val=0;
   for(int i=20; i >= 1; i--)
	{
      if(High[i]>val){
         val=High[i];
      }
   }
return(val);
}

double getLow(){
double val=0;
   for(int i=20; i >= 1; i--)
	{
      if(val==0||Low[i]<val){
         val=Low[i];
      }
   }
return(val);
}

void Trailing(){
   
    double new_sl;
    for(int i = (OrdersTotal()); i >= 0; i --)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
      double ordOp=OrderOpenPrice();
      string ordSym=OrderSymbol();
      int ordTick=OrderTicket();
      int ordType=OrderType();
      double ordTP=OrderTakeProfit();
      double ordSL=OrderStopLoss();
      
      if(ordType==OP_BUY && 
         ((ordSL<ordOp && Bid-ordOp >= dist)||(ordSL>=ordOp && Bid-ordSL>=dist)) 
         && ordSym==Symbol())
            
            {
                    int num=(int)((Bid-ordOp)/dist);
                    new_sl = ordOp + (dist*(num-1));
                    new_sl=NormalizeDouble(new_sl,Digits);
                    
                    if(new_sl>ordSL+10*Point){
                    if(OrderModify(ordTick,ordOp,new_sl,ordTP,0,Blue)){Print("Trade Modified");}
                    }
            }
      
      
      if(ordType==OP_SELL && 
         (((ordSL>ordOp||ordSL==0) && ordOp-Ask >= dist)||(ordSL<=ordOp && ordSL-Ask>=dist))  
         && ordSym==Symbol() )
      
      {
                    int num=(int)((ordOp-Ask)/dist);
                    new_sl = ordOp - (dist*(num-1));
                    new_sl=NormalizeDouble(new_sl,Digits);
                    
                    if(new_sl<ordSL-10*Point||OrderStopLoss()==0){
                    if(OrderModify(ordTick,ordOp,new_sl,ordTP,0,Blue)){Print("Trade Modified");}
                    }
                    
            }
            
         }
   
   }



}
